# Copyright (C) 2001-2004 All right reserved by Shinya Kondo ( CGI KON )

	require "timelocal.pl";
	require "sample.inc" if(-e "sample.inc");

# 

	$SOFT_TITLE = qq!ڥ!;

	$PAGE_TITLE = qq!ͽ!;

	$COPY_TITLE = qq!Powered by CGIKON!;

	@LIST_WEEKS = ("","","","","","","");
	@LIST_COLOR = ("#FF0000","#000000","#000000","#000000","#000000","#000000","#0000FF");
	@LIST_CELLS = ("#FFDBDB","#F5F5F5","#F5F5F5","#F5F5F5","#F5F5F5","#F5F5F5","#BFEEEE");

# վμ

sub Get_Date
{
	my($yyyy,$mm) = @_;

	my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst,$days);
	my(@column) = (0,31,28,31,30,31,30,31,31,30,31,30,31);

	if($yyyy == "" || $mm == "") {
		($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time());
		$yyyy = $year + 1900;
		$mm = $mon + 1;
	}

	my($time) = timelocal(0,0,0,1,$mm - 1,$yyyy);
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($time);
	$yyyy = $year + 1900;
	$mm = $mon + 1;

	if($mm != 2) {
		$days = $column[$mm]
	} elsif($yyyy % 400 == 0) {
		$days = 29;
	} elsif($yyyy % 100 == 0) {
		$days = 28;
	} elsif($yyyy % 4 == 0) {
		$days = 29;
	} else {
		$days = 28;
	}

	return ($yyyy,$mm,$days,$wday);
}

# ץμ

sub Get_Sample
{
	my(%result) = @_;

	my($item,$date,$memo);

	if(open(IFILE,"sample.tsv")) {
		my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
		$year += 1900;

		while(<IFILE>) {
			chomp();
			($item,$date,$memo) = split("\t",$_,3);
			$date =~ s/YYYY/$year/;
			$result{$item}{$date} = $memo;
		}
		close(IFILE);
	}

	return %result;
}

# ͽμ

sub Get_Memos
{
	my($file) = @_;

	my($item,$date,$memo,%result);

	if(open(IFILE,$file)) {
		while(<IFILE>) {
			chomp();
			($item,$date,$memo) = split("\t",$_,3);
			$result{$item}{$date} = $memo;
		}
		close(IFILE);
	}

	return &Get_Sample(%result);
}

# ͽ

sub Set_Memos
{
	my(%value) = @_;

	my($item,$date,$memo,$buff,@result);

	while(($item,$buff) = each(%value)) {
		while(($date,$memo) = each(%$buff)) {
			next if(!$memo);
			push(@result,join("\t",$item,$date,$memo));
		}
	}

	return @result;
}

# ͽκ

sub Del_Memos
{
	my($yyyy,$mm,%value) = @_;

	my($item,$date,$memo,$buff,@result);
	my($key1,$key2,$key3,$vals);

	$vals = $yyyy * 100 + $mm;
	while(($item,$buff) = each(%value)) {
		while(($date,$memo) = each(%$buff)) {
			($key1,$key2,$key3) = split("/",$date);
			next if($key1 * 100 + $key2 <= $vals);
			push(@result,join("\t",$item,$date,$memo));
		}
	}

	return @result;
}

# ƥΥ

sub Print_Item
{
	my($link,$item) = @_;

	my($loop,$href);

	print qq!
		<TABLE BORDER=0 BGCOLOR="#FFFFFF" WIDTH="90%" CELLPADDING="5" CELLSPACING="0">
		<TR>
		<TD>
	!;

	for($loop = 1;$loop <= $#LIST_ITEMS;$loop++) {
		if($loop == $item) {
			print qq!<FONT SIZE=3 COLOR="black"><B>$LIST_ITEMS[$loop]</B></FONT>!;
			next;
		}

		$href = $link."item=$loop";
		print qq!
		<A HREF="$href"><FONT SIZE=2 COLOR="blue">$LIST_ITEMS[$loop]</FONT></A>
		!;
	}

	print qq!
		</TD>
		</TR>
		</TABLE>
	!;
}

# ǯΥ

sub Print_Date
{
	my($link,$yyyy,$mm) = @_;

	my($loop,$href);

	print qq!
		<TABLE BORDER="0" CELLPADDING="5" CELLSPACING="0">
		<TR>
	!;

	for($loop = 1;$loop <= 12;$loop++) {
		$href = $link."yyyy=$yyyy&mm=$loop";
		if($loop == $mm) {
			print qq!<TD><FONT SIZE=3 COLOR="black"><B>$loop</B></FONT></TD>!;
		} else {
			print qq!<TD><A HREF="$href"><FONT SIZE=2 COLOR="blue">$loop</FONT></A></TD>!;
		}
	}

	print qq!
		</TR>
		</TABLE>
	!;
}

# ͽƤɽ

sub Print_Memo
{
	my($item,$yyyy,$mm,$mday,$href,$tags) = @_;

	my($loop,$week,$line,$dd,$link,$date);
	my($note,$buff,$rows,$cols);
	my(@LIST_DATE,@LIST_NOTE,@LIST_FONT,@LIST_TAGS,@column);

	for($loop = 1;$loop <= $mday;$loop++) {
		$week = ($loop + $wday - 1) % 7;
		$line = ($loop + $wday - 1) / 7;
		$line = int($line);

		$date = sprintf("%4d/%02d/%02d",$yyyy,$mm,$loop);
		($note,$buff) = split("\t",$LIST_MEMOS{$item}{$date});

		$LIST_DATE[$line][$week] = $loop;
		$LIST_NOTE[$line][$week] = $note;
		$LIST_FONT[$line][$week] = $LIST_COLOR[$week];
	}

	foreach(@LIST_RESTS) {
		@column = split("/");
		if(int($column[0]) == $yyyy && int($column[1]) == $mm) {
			$dd = int($column[2]);
			$week = ($dd + $wday - 1) % 7;
			$line = ($dd + $wday - 1) / 7;
			$line = int($line);
			$LIST_FONT[$line][$week] = $LIST_COLOR[0];
		}
	}

	$line = $#LIST_DATE;
	$rows = $line + 1;
	$LIST_TAGS[0] = qq!<TD ROWSPAN=$rows VALIGN="top">$tags</TD>!;

	print qq!
		<TABLE BORDER=1 CELLPADDING=5 CELLSPACING=1 WIDTH=800>
		<TR>
	!;

	for($loop = 0;$loop < 7;$loop++) {
		print qq!
			<TD WIDTH=80 HEIGHT=10 ALIGN="center" BGCOLOR="$LIST_CELLS[$loop]">
				<FONT COLOR="$LIST_COLOR[$loop]" SIZE=3><B>$LIST_WEEKS[$loop]</B></FONT>
			</TD>
		!;
	}

	print qq!
			<TD BGCOLOR="$LIST_CELLS[1]" NOWRAP>
				<INPUT TYPE="submit" NAME="last" VALUE="ǯ">
				<FONT SIZE=3 COLOR="black"><B>$yyyyǯ</B></FONT>
				<INPUT TYPE="submit" NAME="next" VALUE="ǯ">
			</TD>
		</TR>
	!;
	for($rows = 0;$rows <= $line;$rows++) {
		print qq!
		<TR>
		!;
		for($cols = 0;$cols < 7;$cols++) {
			$dd = $LIST_DATE[$rows][$cols];
			$link = $href."yyyy=$yyyy&mm=$mm&dd=$dd&edit=TRUE";
			print qq!<TD WIDTH=80 HEIGHT=80 VALIGN="top">
				<A HREF="$link">
				<FONT COLOR="$LIST_FONT[$rows][$cols]"><B>$dd</B></FONT>
				</A><BR>
				<FONT SIZE=2>$LIST_NOTE[$rows][$cols]</FONT><BR>
			</TD>!;
		} 
		print qq!
			$LIST_TAGS[$rows]
		</TR>
		!;
	}
	print qq!
		</TABLE>
	!;
}

1;

# Copyright (C) 2001-2004 All right reserved by Shinya Kondo ( CGI KON )
